//(c) Loe Feijs and TU/e 2014-2016
//Dragon curve using oogway turtle graphics
//and Stitchway Tajima (.dst) output.
//Function names taken from rosettacode.org/wiki/Dragon_curve in logo

import processing.pdf.*;
import nl.tue.id.oogway.*;

float DPMM = 2.834646;//dots per mm (depends on screen)
int XSIZE = int(300 * DPMM);
int YSIZE = int(200 * DPMM);

PGraphicsPDF pdf;
Stitchway o;

void setup() {
     noLoop();
     size(XSIZE,YSIZE);
     pdf = (PGraphicsPDF) beginRecord(PDF, "DRAGON_TAJIMA.pdf");
     o = new Stitchway(this,0,XSIZE,0,YSIZE);
     o.beginRecordTajima("DRAGON_TAJIMA");
}

void dcr(Stitchway o, int step, float len){
     int newstep = step - 1;
     float newlen = len / 1.41421;
     if (step > 0){
        o.right(45);
        dcr(o,newstep, newlen);
        o.left(90);
        dcl(o,newstep, newlen);
        o.right(45);
     }
     if (step == 0){
        o.right(45);
        o.forward(newlen);
        o.left(90);
        o.forward(newlen);
        o.right(45);
     }
}

void dcl(Stitchway o, int step, float len){
     int newstep = step - 1;
     float newlen = len / 1.41421;
     if (step > 0){
        o.left(45);
        dcr(o,newstep, newlen);
        o.right(90);
        dcl(o,newstep, newlen);
        o.left(45);
     }
     if (step == 0){
        o.left(45);
        o.forward(newlen);
        o.right(90);
        o.forward(newlen);
        o.left(45);
     }
}


void draw() {
     fill(0);
     stroke(0);
     background(255);
     o.setPosition(50 * DPMM, 50 * DPMM);
     o.setPenSize(.5);
     o.setHeading(0);
     o.setPenColor(0, 0, 0);
     
     int recursion = 13;
     float dimension = 180 * DPMM;
     dcr(o, recursion, dimension); 
     endRecord();//pdf
     o.endRecordTajima();//dst
}

void stop(){
     endRecord();//pdf
     o.endRecordTajima();//dst
}

